\ 3iRGB.fs - AE - 2022-01-10---Mon---10:18
\ This program provides computer control of stage lights

\ Hardware: 1 SMD RGB LED module - KY XXX
\           1 Nano - pins 9,10,11, and 3,5,6 available for PWM

\ References:
\ Rotary Encoder: https://lastminuteengineers.com/rotary-encoder-arduino-tutorial/

1 open-com
9 out 10 out 11 out

9 constant green
10 constant red
11 constant blue

: rgb-off
  9 lo 10 lo 11 lo
;

: rgb-loop
begin 
    green hi 
    200 ms 
    green lo red hi 
    200 ms 
    red lo blue hi 
    200 ms 
    blue lo
    key?
until 
;

: rgb-fade ( 0 0 0 --- r g b )
begin
  >r >r >r
  r>  7 + 255 mod dup red   pwm 300 ms 
  r> 17 + 255 mod dup green pwm 300 ms 
  r> 13 + 255 mod dup blue  pwm 300 ms
  key?
until
  rgb-off
;

: rgb ( r g b -- ) blue pwm green pwm red pwm ;
